<?php //error_reporting(1);

require('lib/mp3data_manip.inc');
require('lib/id3.inc');

reset($HTTP_POST_VARS);
$filename = rawurldecode($filename);

function cleanup($string, $size){
	$newstring = trim($string);
	if ($size){
		$newstring=substr($newstring, 0, $size);
	}
	return $newstring;
}

// We MUST cleanup whitespace first
$title = cleanup($title, 30);
$artist = cleanup($artist, 30);
$album = cleanup($album, 30);
$year = cleanup($year, 4);
$comment = cleanup($comment, 30);
$genre = cleanup($genre, 0);

// Got tag?
if ($havetag == 1)
  $rw=128;
else 
  $rw=0;

$tag = sprintf ("%-3s%-30s%-30s%-30s%-4s%-30s%-1s","TAG",$title, $artist, $album, $year, $comment, chr($genre));

        if (!($filehandle = fopen("$filename","r+")))
           echo "Can not open file for writing";
        else {
          $size = filesize($filename);

// If there is already a tag, back up 128 chars and overwrite 
// the existing one.  If not, append tag to the end.
          $seek = fseek($filehandle,$size-$rw);
          fputs($filehandle,$tag,strlen($tag));
          if ($havetag)
            echo "Tag successfully updated!<p>";
          else
            echo "Tag successfully added!<p>";
          echo "<a href='$return'>Continue</a>";
}
fclose($filehandle);

clearstatcache();

commitSongToDB($filename);
