<?//php error_reporting(1);
require 'lib/filter_functions.inc';

// Reset this variable
$totalResultSetQuery = '';

msg("search term: $search");

function boolean_parse($search,$field)
{
	if (substr($search, -1, 1) == ')'){
	
	}
	
	//Argument parsing --- ex. ((first || second) && !third)
	if(ereg("^exact_(.*)",$field,$out))
	{
		$field=$out[1];
		$exact=true;
	}
	else
		$exact=false;
	
	for($x=0,$look=0; $x<strlen($search); $x++)
	{
		if(eregi("^(&&|\|\|| and | or )",substr($search,$x),$out) or
			 !ereg("(&&|\|\|| and | or )",substr($search,$look)))
		{
			msg("0- Out[1]: ".$out[1]);
			$tail="";
			$operator=$out[1];
			if(eregi("^(&&|\|\|| and | or )",substr($search,$x)))
				$this_atom=trim(substr($search,$look,$x-$look));
			else
				$this_atom=trim(substr($search,$look));
			if(ereg("^(\(+)(.*)$",$this_atom,$out))
			{
				$args.=trim($out[1]);
				$this_atom=$out[2];
				msg("1args: $args");
			}
				msg ("this_atom here: $this_atom");
			if(ereg("^(.*)(\)+)$",$this_atom,$out))
			{
				msg("out[1]: ". $out[1]);
				$this_atom=trim($out[1]);
				$tail=$out[2];
				msg("2this_atom: $this_atom");
			}
			if(eregi("^(!|NOT )",$this_atom))
			{
				$this_atom=addslashes(stripslashes(trim(eregi_replace("^(!|NOT )","",$this_atom))));
				if($exact){
					$args.="$field <> '".$this_atom."'";
					msg("3args: $args");
				}
				else{
					if(!strchr($this_atom,"%"))
						$this_atom="%$this_atom%";
					$args.="$field NOT LIKE '".$this_atom."'";
					msg("4args: $args");
				}
			}
			else
			{
				msg("this_atom: $this_atom");
				$this_atom=addslashes(stripslashes($this_atom));
				if($exact){
					$args.="$field = '".$this_atom."'";
					msg("5args: $args");
				}
				else
				{
					if(!strchr($this_atom,"%"))
						$this_atom="%$this_atom%";
					$args.="$field LIKE '".$this_atom."'";
					msg("6args: $args");
				}
			}
			msg("tail: $tail");
			$args.=$tail;
			msg("another args: $args");
			if(eregi("^(&&| and )",substr($search,$x)))
				$args.=" AND ";
			elseif(eregi("^(\|\|| or )",substr($search,$x)))
				$args.=" OR ";
			else
				break;
			$x+=strlen($operator);
			$look=$x;
		}
	}

	return($args);
}

$db=new rimpsDB;

require "engine/load_playlist.inc";

if((int)$max<=0)
	$max=50;

if((int)$page<=1)
	$page=1;

/*
// This function doesn't seem to work.  I have problems with it when using the word and
// in a query:  Hootie and the Blowfish, Peter, Paul and Mary, etc.  Even when those artists
// exist, it doesn't find them correctly.  Also when a ) ends a search term it won't work
// song (live) will not return any results, even if there is a song called that.  Because
// of this I've implemented this simple search algorithm below until the boolean search
// can be fixed.

if (!empty($search))
	$where=boolean_parse($search,$display);
else //**Fix for empty querys (query all)
	$where="1=1";
// Must strip '_exact' before using ORDER	
*/
$order=str_replace("exact_","",$display);


// Start simple search algorithm
if ($search != ''){
	if (strstr('exact', $display)){
		$where = "$order = '$search'";
	}
	else{
		$where = "$order LIKE '%$search%'";
	}
}
else{
	$where = ' 1=1';
}

msg("Where: $where");

$q="SELECT ";

// What do we need to select?
if ($display=='artist'){
	$q.= "artist, count(*) as subtotal";
	$g = "artist";
} 
elseif($display == 'album'){
	$q .= "album, artist, count(*) as subtotal";
	$g = "album, artist";
}
else{
	$q .= "*";
}

$q .= " FROM mp3data WHERE $where";

$addQuery = processFilters($filters);
$q .= $addQuery;

// Set this variable so we can all ALL listed items to the current playlist
$totalResultSetQuery = stristr($q, "FROM");

if ($g){
	$q.= " GROUP BY $g";
}

if(!empty($order)) {
	$q.=" ORDER BY $order";

	// albums should be shown in track order
	if ($order == 'album')
		$q .= ", track";
}

//echo "totalResultSetQuery set to $totalResultSetQuery<br>";

msg("Query: $q");

//print "q=$q<br>\n";

$count_query="SELECT count(";
if ($display == 'artist'){
	$count_query .= 'distinct artist';
}
elseif($display=='album'){
	if ($dbconfig['sqlserver'] == 'pgsql'){
		// See comment in browse.inc "IMPORTANT NOTE ABOUT POSTGRESQL"
		$count_query .= '*';
	}
	else{
		$count_query .= 'distinct album, artist';
	}
}
else{
	$count_query .= '*';
}

$count_query .= ") as matched,sum(size) as totalsize, sum(sec) as totaltime FROM mp3data";
if(preg_match("/WHERE (.*?) (GROUP|ORDER|LIMIT)/",$q,$out))
	$count_query.=" WHERE ".$out[1];
msg("count_query: $count_query");
//print "count_query=$count_query<br>\n";
$db->query ($count_query);
$db->next_record();
$total=$db->f('totalsize');
$time = $db->f('totaltime');
if ($dbconfig['sqlserver'] == 'pgsql' && $browse='album'){
	// matched won't be correct for PostgreSQL.  See comment IMPORTANT NOTE ABOUT POSTGRESQL
	// in browse.inc
	$db->query($q);
	$matched = $db->num_rows();
}
else{
	$matched=$db->f('matched');
}


msg("Total: $total");
msg("Matched: $matched");
msg("Time: $time");

// Add limits
if ($dbconfig["sqlserver"] == "mysql")
	$q.=" LIMIT ".(($page-1)*$config["num_per_page"]).",".($config["num_per_page"]);
elseif ($dbconfig["sqlserver"] == "pgsql")
	$q.=" LIMIT ".($config["num_per_page"]).",".($config["num_per_page"]*($page-1));

$db->query($q);

$browse = 'title';


if ($display=='artist'){
	$browse='artist';
}
elseif($display == 'album'){
	$browse = 'album';
}

require 'layout/pager.inc';

$showMusicTitle = "Results for <b>\"$search\"</b> in <b>$display</b>";

require "layout/show_music.inc";

require 'layout/pager.inc';

?>
