<?
// Functions to assist in client management
//msg("included client management functions");
function clientSelectBox($name, $clients=''){
	// Creates a multiple select box with the $name given.  $clients can
	// either be passed as a string or an array
	//msg("Clients: $clients");
	if (!is_array($clients)){
		// Convert comma delimited list to an array
		$clients = createClientArray($clients);
	}
	if (is_array($clients)){
		// Now build an array with clients as the index
		reset($clients);
		while(list($tmp, $client) = each($clients)){
			$clientList[trim($client)] = 1;
		}
	}
	$db = new rimpsDB;
	$sql = "SELECT name FROM clients";
	$db->query($sql);
	echo "<select multiple name='$name'>\n";
	/*
	echo "<option";
	if ($clientList['Default']){
		echo " SELECTED ";
	}
	echo ">Default\n";
	*/
	while ($db->next_record()){
		echo "<option";
		if ($clientList[$db->f('name')]){
			echo ' SELECTED ';
		}
		echo ">".$db->f('name');
	}
	echo "</select>	\n";	
}

function determineClient(){
	// Return the name of the client or client group the user
	// belongs to
	$db = new rimpsDB;
	$sql= 'SELECT * from clients ORDER BY priority DESC';
	$db->query($sql);
	if ($db->num_rows()<1){
		$client = 'Default';
	}
	else{
		while($db->next_record()){
			// Postgres seems to add spaces at the end of some fields.  Odd.
			// Using trim to remove extra space.
			$pattern = '^'.str_replace('*', '[[:digit:]]+', trim($db->f('ip_pattern'))).'$';
			if (ereg($pattern, $GLOBALS['REMOTE_ADDR'])){
				$client = $db->f('name');
				break;
			}
		}
	}
	msg ("Client determined: $client");
	if ($client == ''){
		$client = 'Default';
	}
	return $client;
}

function createClientString($clients){
	// Takes an array and returs a string of clients to be added 
	// to the database.
	if (is_array($clients)){
		reset($clients);
		$string = '|';
		while(list($tmp, $client) = each($clients)){
			$string.=$client.'|';		
		}
	}
	return $string;
}

function createClientArray($string){
	// Takes a string of clients from the database and converts it into
	// an array
	$string=substr($string, 1,strlen($string)-2);
	$clients = explode('|', $string);
	return $clients;
}
?>