<?
// Functions which facilitate working with playlists

function createNewPlaylist($playname){
	global $auth, $playlist_id;
	$db = new rimpsDB;
	$db->query("INSERT INTO playlist (name,owner) VALUES ".
						 "('".addslashes(stripslashes($playname))."','".$auth->auth["uname"]."')");
	// Set the active playlist to the one just added
	$query = "SELECT MAX(id) AS id FROM playlist WHERE owner = '" . $auth->auth['uname'];
	$query .= "' AND name = '$playname'";
	$db->query($query);
	if ($db->num_rows() > 0){
		$db->next_record();
		$playlist_id = $db->f('id');
		//echo "Set playlist id to ".$playlist_id."<br>";
	}
}

function showPlaylistName($playlist_id){	
	$db=new rimpsDB;
	$db->query("select name from playlist where id = " . $playlist_id);
	$db->next_record();
	//$GLOBALS['theme']->edge_title('Current Playlist', $GLOBALS['config']['site_width']/2);

	echo "Playlist: ";
	?>
	<input type=text name=newplaylistname value = "<? echo $db->Record["name"]?>" size=15>
	<input type="Submit" value = "Rename">
	<input type="Hidden" name="oldplaylistname" value = "<? echo $db->Record["name"]?>">
	<? if ($GLOBALS['perm']->have_perm('download') && $GLOBALS['config']['allow_download'] == 'yes'){
		// Link to download playlist?>
		<a href="download.php/mp3.tar">
		<img src="<?echo $GLOBALS['config']['imgdir']?>/download.gif" border=0 alt="Download this playlist in .tar format">
		</a><br>
		
	<?}
	//$GLOBALS['theme']->edge_title_end();
}

function playlistEntryIcon($playlist_id){
	global $playlistParents;
	msg("playlistParents[$playlist_id]: ".$playlistParents[$playlist_id]);
	if ($playlistParents[$playlist_id]){
		echo '<img src="'.$GLOBALS['config']['imgdir'].'/folder.gif" border=0 alt="Open folder without changing current view"> ';
	}
	else{
		echo '<img src="'.$GLOBALS['config']['imgdir'].'/arrow.gif" border=0 alt="Select playlist without changing current view"> ';
	}
}

function showPlaylistEntry($id, $name, $playlist_id, $level=0){
	// Build a URL consisting of all the current stuff, and add to the end
	// the new playlist ID.  This should let us change playlists without
	// interrupting searches or browsing we are currently doing.
	
	$url = "http://".$GLOBALS['HTTP_HOST'].$GLOBALS['config']['baseurl']."?browse=".$GLOBALS['browse']."&page=".$GLOBALS['page']."&search=".urlEncode($GLOBALS['search'])."&index=".$GLOBALS['index']."&sort=".$GLOBALS['sort']."&display=".$GLOBALS['display'];
	if ($GLOBALS['action'] =='submit' || $GLOBALS['action'] =='dellist' ){
		$url .= "&action=".$GLOBALS['formerAction'];
	}
	else{
		$url .= "&action=".$GLOBALS['action'];
	}
	
	// Indent if this is a deeper level
	echo "<tr nowrap><td nowrap>";
	for ($i=0; $i<$level; $i++){
		echo "&nbsp;&nbsp;&nbsp;&nbsp;";
	}
	if ($playlist_id == $id){
		echo '<b>';
		playlistEntryIcon($id);
		// Set a global variable with the current playlist name so we can access it elsewhere in the
		// program
		$GLOBALS['currentPlaylistName'] = $name;
		echo '</b>';
	}
	else {
		echo "<a href='$url&playlist_id=$id'>";
		playlistEntryIcon($id);
		echo '</a>';
	}
	//echo "</td><td nowrap>";
	$db2 = new rimpsDB;
	$query = "select count(*) as total from playlist_detail where playlist_id = $id";
	$db2->query($query);
	$db2->next_record();
	$total = $db2->f("total");
//	$db2->free();

	// Bold selected playlist
	if ($playlist_id == $id){
		echo '<b>';
	}
	echo "&nbsp;&nbsp;". createLink("playlist", $name . " ($total)","","","","","","","","playlist_id=$id");
	echo "</td><td nowrap>";
	if ($playlist_id == $id){
		echo '</b>';
	}	
	createLink("dellist", "Del ", "","","","","","","","playlist_id=$id");
	echo "</td><td>";
	echo "<a href='".$GLOBALS['config']['playlist'].$GLOBALS['config']['playlist_ext']."?playlist_id=$id'>Play</a>";
	echo "</td></tr>";
}

function deletePlaylist($playlist_id){
	$db = new rimpsDB;
	msg("deleting playlist $playlist_id");
	// First find the children
	// Added where owner=user for increase security
	$sql = "SELECT id FROM playlist WHERE parent = $playlist_id AND owner='".$GLOBALS['auth']->auth['uname']."'";
	$db->query($sql);
	if ($db->num_rows()>0){
		while ($db->next_record()){
			// Note, there could be a circular reference here, but it the interface should
			// prevent that, therefore we won't do any checking for it
			deletePlaylist($db->f('id'));
		}
	}
	
	$db->query("DELETE FROM playlist_detail WHERE playlist_id = " . $playlist_id);
	$db->query("DELETE FROM playlist WHERE id = " . $playlist_id);
}

?>