<?
require 'application.inc';
//page_open(array("sess"=>"rimpsSess", 'auth' => 'rimpsAuth', 'perm' => 'rimpsPerm'));
//$perm->check('rescan');
?>
<head>

</head>
<?
writeThemedBodyTag();
$db = new rimpsDB;
//$sql = "UPDATE mp3data SET lastmod = 0";
//$db->query($sql);
require 'layout/header.inc';
?>
<p>

<?php

require 'lib/id3.inc';
require 'lib/vorbis.inc';
require 'lib/mp3data_manip.inc';
// mp3info library
//require 'lib/mp3info.inc';
set_time_limit($config['max_rescan_time']);


function trackProgress(){
	// Echos out a . to show progress as long processes are working
	global $tracking;
	$tracking++;
	if ($tracking > 200){
		$tracking=1;
		echo "<br>\n";
	}
	echo '.';
	flush();
}

function recurse ($bspath, $nxpath, $locationID)
{
	// starting from the local_storage array...
	// get all subdirectories recursively

	// $dirCounter is a temp variable used for debugging.  It counts the
	// number of open directories

	global $dirlist, $locIDs, $dirCounter;

	msg ("Recursing $bspath, $nxpath");
	// Debug
	if (file_exists($nxpath)){
		msg("File $nxpath exists");
		if (is_dir($nxpath)){
			msg("File is a directory");
		}
		else{
			msg("File is NOT a directory");
		}
	}
	else{
		msg ("File $nxpath does not exist!");
	}
	$dirhandle = dir($nxpath);
	msg("Open directories: ".++$dirCounter);
	while ($direct = readdir($dirhandle->handle))
	{
		msg("Directory entry: $direct");
		$GLOBALS['num']++;
		if ($GLOBALS['num']%80 == 0){
			trackProgress();
		}
		$nxpath=$bspath . "/" . "." . "/" . $direct;
		msg("nxpath: $nxpath");
		if (is_dir($nxpath) && $direct!="." && $direct!="..")
		{
				$nxpath = str_replace("/./","/",$nxpath);
				$dirlist[count($dirlist)]=$nxpath;
				$locIDs[$nxpath] = $locationID;
				msg ("Found directory $nxpath");
				recurse ($nxpath, $nxpath, $locationID);
		}
	}
	$dirhandle->close();
	$dirCounter--;
}



echo "<font size=-1>";

// Build a list of locations to query
$sql = "SELECT id, name, basedir FROM mp3location";
if ($index){
	$sql .= " WHERE id = $index";
}
$db->query($sql);
while ($db->next_record()){
	$scanLocations[$db->f('basedir')] = $db->f('id');
	$scanLocationNames[$db->f('id')] = $db->f('name');
}

if (!is_array($scanLocations)){
		echo "No locations to scan, or location does not exist";
		exit;
}

$locations = implode(', ', $scanLocationNames);
echo "Preparing to scan MP3 locations: $locations<br>\n";
flush();
$tracking=0;
$num=0;

// Set verified for all files to 0, so we can see at the end of this, which ones no longer exist.
$sql = "UPDATE mp3data SET verified=0";
$db->query($sql);


// $dirlist contains a list of directories to be scanned
// $locIDs maps each directory location to an ID as found in the database
reset($scanLocations);
while(list($local_path, $id)=each($scanLocations))
{
	$path=$local_path;
	msg("Path: $path");
	$dirlist[count($dirlist)]=$local_path;
	$locIDs[$local_path] = $id;
	msg("ID: $id");
	recurse($path, $path, $id);
}

echo "<br>\n";
echo "Scanning ".count($dirlist)." directories in the library<br>\n";

$added=0;
$tracking =0;
$numMP3=0;

// For each path in the local_storage array...
for ($qz = 0; $qz <= count($dirlist)-1; $qz++){
	// Iterate through each directory in the list looking for MP3s.
	$dirhandle = dir($dirlist[$qz]);
	//echo "Scanning ". $dirlist[$qz]. "<br>\n";
	//flush();
	$path = $dirhandle->path;
	// Set the current location
	$currentLocation = $locIDs[$dirlist[$qz]];
	// Grab the files and read the tags
	while ($file = readdir($dirhandle->handle)){
		// Track progress one out of every 10 iterations
		if ($qz%10==0) trackProgress();
		if ($file != "." && $file != ".."){
			$ext = strtoupper(substr("$file",strlen("$file")-4));
			if ($ext == '.MP3' || $ext == '.OGG') {
				// We found an MP3!
				$file = "$path/$file";
				$numMP3++;
				if ($ext == '.MP3')
					$codec = 'mpeg';
				elseif ($ext == '.OGG')
					$codec = 'vorbis';
				else die("oops");

				$whatChanged = commitSongToDB($file, $codec, $currentLocation);
				// $whatChanged will either be 'added', 'updated', or 'failed'  we want to increment the
				// variable by that name so we can track what has been done
				$$whatChanged++;
			}
		}
	}
	$dirhandle->close();
}

// Sometimes a file may have just been moved.  If 'friendly_moves' is enabled
// This routine will attempt to detect this situation and remap the new file
// to the id id previously had in the database.  This way playlists will not
// be disrupted
$tracking =0;
if ($config['friendly_moves'] == 'yes' && is_array($fileAdded)){
	echo "<br>Looking for files which have moved<br>\n";
	// Get the "orphans" to see if they have moved
	$sql = "SELECT * FROM mp3data WHERE verified =0";
	if ($index != ''){
		$sql .= " AND loc_id = $index";
	}
	$db->query($sql);
	if ($db->num_rows()>0){
		while($db->next_record()){
			reset($fileAdded);
			while(list($ind, $mp3d) = each($fileAdded)){
				$counter++;
				if ($counter%300== 0) trackProgress();
				$oID = $db->f('id');
				$oTitle = $db->f('title');
				$oArtist = $db->f('artist');
				$oAlbum = $db->f('album');
				$nID = $ind;
				$nTitle = $mp3d['title'];
				$nArtist = $mp3d['artist'];
				$nAlbum = $mp3d['album'];
				// Look for some exact matches
				if ($oTitle == $nTitle){
					$points["$nID|$oID"] += 10;
				}
				if ($oArtist == $nArtist){
					$points["$nID|$oID"] += 3;
				}
				if ($nAlbum == $oAlbum){
					$points["$nID|$oID"] += 5;
				}
				// Now do some fuzzy comparison
				if (soundex($oTitle) == soundex($nTitle)){
					$points["$nID|$oID"] += 5;
				}
				if (soundex($oArtist) == soundex($nArtist)){
					$points["$nID|$oID"] += 2;
				}
				if (soundex($oAlbum) == soundex($nAlbum)){
					$points["$nID|$oID"] += 2;
				}
			}
		}
		// Sort results
		arsort($points, SORT_NUMERIC);
		reset($points);
		msg("points sorted");
		while (list($relation, $value) = each($points)){
			$counter++;
			if ($counter%300 ==0) trackProgress();
			msg ("relation/value: $relation/$value");
			if ($value >0){
				$parts = explode('|', $relation);
				if (!$alreadyDone[$parts[1]]){
					// Delete the old one
					$sql = "DELETE FROM mp3data WHERE id = ". $parts[1];
					msg($sql);
					$db->query($sql);
					// Update the ID
					$sql = "UPDATE mp3data SET id = ". $parts[1]. " WHERE filename = '".addSlashes($fileAdded[$parts[0]]['filename'])."'";
					msg($sql);
					$db->query($sql);
					$moved++;
					$alreadyDone[$parts[1]] = 1;
				}
			}
		}
	}
}

echo "<br>\n";
echo "Scan Complete. Found $numMP3 mp3s<br>\n";
echo "</font>";

$added = $added - $moved;

$GLOBALS["theme"]->edge($GLOBALS["defwidth"]);
print "<font size=+2>";
print "Successfully added ".(int)$added." mp3s<br>\n";
print "Updated " . (int)$updated . " mp3s<br>\n";
print "Found ". (int)$moved." mp3s that had moved<br>\n";
print "Failed to add ".(int)$failed." mp3s<br>\n<hr>";
// Find how many orphaned rows in database (no longer have an associated file)
$sql = "SELECT count(*) AS number FROM mp3data WHERE verified =0";
if ($index){
	$sql .= " AND loc_id = $index";
}
$db->query($sql);
$db->next_record();
$orphaned = $db->f('number');
if ($orphaned){
	echo "Found $orphaned orphaned entries in the library <a href='".$config['baseurl']."?action=delete_orphans'>(Delete)</a><br>\n";
}
print "</font>\n";
$GLOBALS["theme"]->edge_end();
page_close();
?>


