<?
require 'application.inc';
page_open(array("sess"=>"rimpsSess", 'auth' => 'rimpsAuth', 'perm' => 'rimpsPerm'));
$perm->check('rescan');
?>

<head>

</head>
<?
writeThemedBodyTag();
$db = new rimpsDB;
require 'layout/header.inc';
?>
<p>

<?
if ($upgrade == ''){
	echo "<center><form action=upgrade.php>";
	$GLOBALS['theme']->edge_title('Choose Upgrade Path', $GLOBALS['config']['site_width']/2);
	echo "Upgrade: ";
	echo "<select name=upgrade>";
	echo "<option value='0.06-1.0'>0.06 -> 1.0";
	echo "<option value='1.0-3.0'>1.0 -> 3.0";
	echo "</select>";
	echo " <input type=submit value=Upgrade>";
	$GLOBALS['theme']->edge_title_end();
	echo "</form></center>";
	exit;
}

function upgradeDatabase($file){
	if (!file_exists($file)){
		echo "Error: Database upgrade file $file does not exist";
		exit;
	}

	$db = new rimpsDB;

	// Read in the upgrade SQL
	$sqlArray = file($file);
	if (is_array($sqlArray)){
		$sql = implode('', $sqlArray);
		// Separate out individual statements
		$sqlStatements = explode(';', $sql);
		if (is_array($sqlStatements)){
			reset($sqlStatements);
			while(list($temp, $sql) = each($sqlStatements)){
				if (trim($sql) != ''){
					echo "$sql<br>\n";
					$db->query($sql);
				}
			}
		}
	}
}

$sqlUpgradeFile = "docs_info/upgrade/$upgrade.".$dbconfig['sqlserver'];
$scriptUpgradeFile = "docs_info/upgrade/$upgrade.inc";
$scriptUpgradeFile2 = "docs_info/upgrade/$upgrade-2.inc";
if (file_exists($sqlUpgradeFile) && file_exists($scriptUpgradeFile) && file_exists($scriptUpgradeFile2)){
	echo "Starting upgrade<p>";
	include($scriptUpgradeFile);
	upgradeDatabase($sqlUpgradeFile);
	include($scriptUpgradeFile2);

}
else{
	echo "An upgrade path from $upgrade does not exist OR you have not yet installed the new RIMPS files.
	Remember to copy over your old RIMPS files with the ones from the new distribution BEFORE running this program.";
}