<?
// There are two types of filters:  System filters, and user-defined filters.  System filters
// exist for all users, but may be turned on or off.  System filters are defined by this include
// file.  User-defined filters exist only in the database and are defined by the end user.

// Shows only available files when turned on.
// Don't mess with this filter.  The system needs it!
$sysFilter['showAvailable']['field'] = 'available';
$sysFilter['showAvailable']['relationship'] = '=';
$sysFilter['showAvailable']['filter_value'] = 1;
$sysFilter['showAvailable']['value_type'] = 'number';
$sysFilter['showAvailable']['display'] = 'Show only available files';
$sysFilter['showAvailable']['active'] = 1; // enabled by default


// Filters below this point can be played with.  Here is an example filter.
// To add additional system filters, copy the example below

// Shows only files with a bitrate of at least 128
$sysFilter['128bitrate']['field'] = 'bitrate'; 		// Field in mp3data to be compared
$sysFilter['128bitrate']['relationship'] = '>=';	// Equality operator to use
$sysFilter['128bitrate']['filter_value'] = 128;		// Value to compare $field against
$sysFilter['128bitrate']['value_type'] = 'number';	// Type of value.  "string" or "number"
$sysFilter['128bitrate']['display'] = 'Show only files with bitrate of at least 128';
							// A friendly description for this filter
$sysFilter['128bitrate']['active'] = 0; 		// Enabled (1) or disabled (0) by default

?>