<?
require 'application.inc';
require 'lib/tar.inc';
set_time_limit($config['max_download_time']);
page_open(array("sess"=>"rimpsSess", 'auth' => 'rimpsAuth', 'perm' => 'rimpsPerm'));
if (!$perm->have_perm('download')){
	// Error: The user does not have download permissions
	header("Location: ".$config['baseurl']."?action=no_download_perm");
	exit;
}
if ($config['allow_download'] != 'yes'){
	// Error: Server is not configured to allow files to be downloaded
	header("Location: ".$config['baseurl']."?action=downloading_disabled");
	exit;
}
if (!$playlist_id){
	// Error: No playlist selected
	header("Location: ".$config['baseurl']."?action=downloading_no_playlist");
	exit;
}

// Set tar content-type header
header('Content-type: application/x-tar');
$db = new rimpsDB;
include('engine/load_playlist.inc');
// $playlist_arr now contains songs in current playlist
$list = implode(',', $playlist_arr);
$query = "select filename, title from mp3data where id in ($list)";
$db->query($query);
if ($db->num_rows() > 0){
	while ($db->next_record()){
		$file[] = $db->f('filename');
	}
}

// Tar it up!
createTar($file);

?>