<script language="JavaScript">
function Cancel(){
	document.location = "<?echo $config['baseurl']."?action=location_admin"?>";
}

function goBack(){
	window.history.go(-1);
}
</script>
<?



// Add location wizard.  Walks the user through a series of screens that allows the user to
// add a location containing MP3s to RIMPS.
//
// Notes: 
//    if we are editing, $index will be passed in as the loc_id.  We save this in loc_change.
//    if we are adding an access path, noDefault will be set.  We save this in loc_noDefault
// 



function writeHiddenFields($showAll=0){
	
	// Setting showAll will write all hidden fields regardless of the stage
	
	global $warningMsg, $stage;
	if ($GLOBALS['nextStage'] == ''){
		$GLOBALS['nextStage'] = $stage;
	}
	echo "<input type='hidden' name='stage' value='".$GLOBALS['nextStage']."'>";
	echo "<input type='hidden' name='prevStage' value='".$GLOBALS['stage']."'>";
	echo "<input type='hidden' name='action' value='".$GLOBALS['action']."'>";
	echo "<input type='hidden' name='loc_change' value='".$GLOBALS['loc_change']."'>";
	echo "<input type='hidden' name='loc_accessPath' value='".$GLOBALS['loc_accessPath']."'>";
	echo "<input type='hidden' name='loc_noDefault' value='".$GLOBALS['loc_noDefault']."'>";
	if (is_array($GLOBALS['warningMsg'])){
		echo "<input type='hidden' name='wasWarning' value='1'>";
	}
		
	// Do stage-specific variables here
	if ($stage!='start' || $showAll){
		echo "<input type='hidden' name='loc_dir' value='".stripSlashes($GLOBALS['loc_dir'])."'>";
		echo "<input type='hidden' name='loc_name' value='".stripSlashes($GLOBALS['loc_name'])."'>";
	}
	if ($stage!='access point' || $showAll){
		echo "<input type='hidden' name='loc_url' value='".stripSlashes($GLOBALS['loc_url'])."'>";
	}
	if ($stage!='clients' || $showAll){
			echo "<input type='hidden' name='loc_clients' value='".($GLOBALS['loc_clients'])."'>";
	}
	
	
}

function lookForMP3($dir){
	// Recursively searches $dir for files ending in .mp3.  If one is found the file name
	// is returned.  If not, an empty string is returned.
	msg("Got dir $dir");
	$d=dir($dir);
	while ($file = $d->read()){
		//echo "File: $file<br>";
		if ($file != '.' && $file != '..'){
			if (is_dir($dir.'/'.$file)){
				//echo "Found directory<br>";
				return (lookForMP3($dir.'/'.$file));
			}
			if (strtolower(substr($file, -4, 4)) == '.mp3'){
				return($dir.'/'.$file);
			}
		}
	}
	return '';
}

// Set default stage
if ($stage==''){
	$stage = 'start';
}

// Check to see if this is NOT a default access path.  If not, we need to set $loc_noDefault
if ($GLOBALS['noDefault'] != ''){
	$GLOBALS['loc_noDefault']=$GLOBALS['noDefault'];
}


// If $index is set, then we are editing a location, not adding a new one.  We need to select
// the data for the location designated by $index
if ($index!=''){	
	msg("Loading information to be edited");
	$db->query("SELECT * from mp3location WHERE id=$index");
	if ($db->next_record()){
		$loc_name = $db->f("name");
		$loc_type = $db->f("type");
		$loc_dir = $db->f("basedir");
		msg ("loc_dir: $loc_dir");
		//$loc_baseurl = $db->f("baseurl");
		$loc_comment = $db->f("description");
		$loc_available = $db->f("available");
		$loc_first_seen = $db->f("first_seen");
		$loc_last_seen = $db->f("last_seen");
		$loc_seconds_online = $db->f("seconds_online");
		$loc_last_update = $db->f("last_update");
		$title="Edit Location";
	}
	
	// Now get the default access path if this is default...
	if (!$loc_noDefault){
		$sql = "SELECT mount_point from network_mappings WHERE loc_id = $index and is_default=1";
		$loc_url = $db->simple_query($sql);
	}
	
	// If we passed in $accessPath then we are EDITING a non default path and we need to load
	// it
	if ($accessPath){
		$sql = "SELECT * FROM network_mappings WHERE loc_id = $index AND mount_point = '$accessPath'";
		$db->query($sql);
		if ($db->num_rows()<1){
			echo "Error.  $accessPath does not seem to exist";
			exit;
		}
		else{
			$db->next_record();
			$loc_url = $db->f('mount_point');
			msg("loc_url: $loc_url");
			$loc_clients = $db->f('clients');
		}
		// Store in in this variable so it will be propogated from page to page in the
		// hidden vars.
		$loc_accessPath = $accessPath;
	}
	
	// $loc_change is the variable that will be carried from page to page in the wizard
	// and holds the loc_id (pass in $index)
	$loc_change = $index;
}



/////////////////////////////////////////////////////////////////////////////////
// Data validation for each stage

// Don't do validation if the last screen was a warning...

if (!$wasWarning){

	$errorMsg='';
	$warningMsg = '';
	if ($prevStage=='start'){
		// Clean up $loc_dir
		$loc_dir = str_replace("\\", '/', $loc_dir);
		$loc_dir=ereg_replace('/$','',$loc_dir);

		if ($loc_dir == ''){
			$errorMsg[]= "Please enter a directory where MP3s are stored.  ";
		}
		// Check to see if directory can be reached...
		elseif (!is_dir($loc_dir)){
			$errorMsg[]= "The directory $loc_dir does not exist or is not a directory.  Please enter a valid directory.  ";
		}
		elseif(!is_readable($loc_dir)){
			$errorMsg[]="The directory $loc_dir is not readable to RIMPS.  Please modify permissions on this directory to make it readable.  Try chmod a+r <dirname>.  ";
		}

		if(!is_writable($loc_dir)){
			$warningMsg[]="The directory $loc_dir is not writable to RIMPS.  This means that you will not be able to use the built-in ID3 editor.  ";
		}

		// Check to see if MP3 files can be found...
		$exampleFile = lookForMP3($GLOBALS['loc_dir']);

		if ($exampleFile == ''){
			$warningMsg[] = "Unable to find an MP3 file in directory ".$GLOBALS['loc_dir'].".";
		}

		if ($loc_name ==''){
			$errorMsg[]="Please choose a friendly name for this location.  ";
		}
	}

	if ($prevStage=='access point'){
		if ($loc_url == ''){
			$errorMsg[]="Please enter how you'd like the files in ".$GLOBALS['loc_dir']." to be accessed";
		}

		// Try to read a file in the location specified.

		if ($loc_url != ''){
			// Translate an \ to /
			msg("loc_dir: $loc_url");
			// Get a file
			if (substr($loc_url, 0 ,2)=="\\\\"){
				$warningMsg[] = stripSlashes($loc_url)." appears to be a network share.  Because PHP4 does not support network paths at this time, RIMPS cannot verify that the path you've entered is correct.  However, most players (WinAMP) can access network shares just fine.  As long as you are certain that this path points to the files in $loc_dir, this configuration should work.";
			}
			else{
				$exampleFile = lookForMP3($GLOBALS['loc_dir']);
				msg("Example file found: $exampleFile");
				// Remove the base $loc_dir from the file
				$testFile = str_replace($loc_dir, "$loc_url", stripSlashes($exampleFile));
				// If the protocol is http, we need to change spaces to %20
				if (strToLower(substr($testFile, 0, 4)) == 'http'){
					$testFile = str_replace(' ', '%20', $testFile);
				}
				@$test = fopen($testFile,'r');
				if (!$test){
					$warningMsg[]= "Unable to open the mp3 file $testFile.  This file should be available if $loc_url is a valid access path for $loc_dir.  It is recommended that you re-evaluate your access path entry.";  
				}
				else{
					fclose($test);
				}
			}
		}

	}

	if ($prevStage=='clients'){
		// Validation of clients
		if (!is_array($clients)){
			$errorMsg[]= "You must select at least one client for which you would like this access path used";
		}
		else{
			$loc_clients = createClientString($clients);
		}
	}

	// End of data validation
}


// We want a different title of the form if we are editing or adding
if ($index != '' || $loc_change != ''){
	$formTitle = "Edit Location";
}
else{
	$formTitle = "Add New Location";
}

// Start of form
$GLOBALS["theme"]->edge_title("$formTitle Wizard",floor($GLOBALS["defwidth"]/2));
echo "<form action='$PHP_SELF' method=POST><center>\n";
if ($errorMsg){
	echo "<br><ul><font color=red>";
	reset($errorMsg);
	while(list($tmp, $msg) = each($errorMsg)){
		echo "<li>$msg";
	}
	echo "</font></ul>";
	$stage = $prevStage;
}
echo "<br>";

if ($warningMsg && $errorMsg == '' && $skipWarning==''){
	// Display Warning message
	echo "<table border=0 cellspacing=0 cellpadding=5><tr><td>";
	echo "<b>Warning:</b><ul>";
	reset($warningMsg);
	while (list($tmp, $msg) = each ($warningMsg)){
		echo "<li>$msg";
	}
	echo "</ul>";
	echo "Press your back button to change your previous entry, or press the continue button to continue.<p>";
	echo "</td></tr><tr><td align=right>";
	echo "<input type=button name=backButton value='&lt; Back' onClick='goBack()'> <input type=submit name=skipWarning value='Continue &gt;'>";
	echo "</td></tr></table>";
}
else{
	if ($stage=='start'){
		// Get name of mount point, and directory.
		echo "<table border=0 cellspacing=0 cellpadding=0>";
		echo "<tr><td align=right><b>Directory:</b></td>";
		echo "<td><input type=text name=loc_dir value='$loc_dir' size=40></td>\n";
		echo "</tr><tr><td></td>";
		echo "<td>Enter the path to a directory where MP3s are stored.  Example: c:/music/mp3s or /home/bob/mp3s.  Note that network shares are not currently supported.</td>";
		echo "<tr><td>&nbsp;</td></tr>";
		echo "<tr><td align=right><b>Name:</b></td>";
		echo "<td><input type=test name=loc_name value='$loc_name' size=40></td></tr>\n";
		echo "<tr><td></td><td>";
		echo "Choose a friendly name for this location. (Example 'C: Drive')</td></tr>\n";
		echo "<tr><td>&nbsp;</td></tr>";
		echo "<tr><td></td><td align=right> <input type=button value=Cancel onClick='Cancel()'>";
		echo " <input type=submit name=continue value='Continue &gt;'>";
		echo "</table>";
		$nextStage='access point';
	}

	if ($stage=='access point'){
		// Get access point 
		
		// Set an adjective if this is the default access path:
		if (!$loc_noDefault){
			$adj = "Default ";
		}
		msg("loc_url: $loc_url");
		if ($loc_url == ''){
			$loc_url = "http://$SERVER_NAME";
		}
		
		echo "<table border=0 cellspacing=0 cellpadding=5>";
		echo "<tr><td><b>";
		echo "$adj Access Path:</b></td></tr>";
		echo "<tr><td><input type=text name=loc_url value='$loc_url' size=40></td></tr>";
		echo "<tr><td align=right><input type=button name=continue value=Cancel onClick='Cancel()'>";
		// Don't show back button here if we are editing or adding a non-default
		// access path
		if (!$loc_noDefault){
			echo " <input type=button name=backButton value='&lt; Back' onClick='goBack()'>";
		}
		echo " <input type=submit name=continue value='Continue &gt;'></td></tr>";
		echo "<tr><td>&nbsp;</td></tr>";
		echo "<tr><td>";
		echo "Provide the <b>".strToLower($adj)."</b> way you want the files in $loc_dir to be accessed.  Start with http:// if the files will be accessed via the web.  Enter '$loc_dir' to allow local access only.  Enter the directory name (\\\\server\\path) to allow access over the local network.  You will be able to configure additional ways of accessing this MP3 location later if you like.  ";
		echo "<p>Examples:";
		echo "<ul>";
		$example = ereg_replace('^([^/])*(/)*', '', $loc_dir);
		echo "<li>Web access-- http://www.server.com/music/$example";
		echo "<li>Local access-- $loc_dir";
		echo "<li>Local network-- //server/$example";
		echo "</ul>";
		echo "</td></tr>";
		echo "</table>";
		if ($loc_noDefault){
			$nextStage = 'clients';
		}
		else{
			$nextStage = 'final review';
		}
		
	}
	
	if($stage=='clients'){
		// Input clients if this isn't the default
		// Skip this stage if we aren't working on a non-default path.
		echo "<table border=0 cellspacing=0 cellpadding=5>";
		echo "<tr><td>";
		echo "<b>Access Path:</b> $loc_url<p>";
		echo "Please choose the clients for which this access path should be used:<br>";
		echo "<center>";
		clientSelectBox('clients[]', $loc_clients);
		echo "</center>";
		echo "</td></tr><tr><td align=right>";
		echo " <input type=button name=continue value=Cancel onClick='Cancel()'>";
		echo " <input type=button name=backButton value='&lt; Back' onClick='goBack()'>";
		echo " <input type=submit name=continue value='Continue &gt;'>";
		
		echo "</td></tr></table>";
		
		$nextStage = 'final review';
	}
	
	if($stage=='final review'){
		// Final review, get comment
		
		// Set an adjective if this is the default access path:
		if (!$loc_noDefault){
			$adj = "Default ";
		}
		echo "<table border=0 cellspacing=0 cellpadding=5>";
		echo "<tr><td>";
		echo "<b>Directory:</b> $loc_dir<br>";
		echo "<b>Name:</b> $loc_name<br>";
		echo "<b>$adj Access Path:</b> $loc_url<p>";
		echo "Comments:<br>";
		echo "<input type=text name=loc_comment value='".stripSlashes($loc_comment)."' size=50>";
		echo "<br>";
		echo "</td></tr><tr><td align=right>";
		echo "<input type=button value=Cancel onClick='Cancel()'> ";
		echo "<input type=button name=backButton value='&lt; Back' onClick='goBack()'> ";
		echo "<input type=submit value='Save'> ";
		echo "</td></tr>";
		echo "</table>";
		$nextStage='commit';
	}
	
	if($stage=='commit'){
		if ($loc_change==''){
		// Add to the database
			rimps_msg("New location added");
			$db->query("INSERT INTO mp3location ".
				"(name,description,first_seen,last_seen, ".
				"last_update,seconds_online,available,basedir) ".
				"VALUES ('$loc_name', '$loc_comment', NOW(), NOW(), ".
				"NOW(), '0', '1', '$loc_dir')");

			if ($dbconfig["sqlserver"]=="mysql"){
				// get primary key
				$index= $db->simple_query("SELECT LAST_INSERT_ID() FROM mp3location");
			} elseif($dbconfig["sqlserver"]=="pgsql"){
				$index = $db->simple_query("SELECT currval('mp3location_id_seq')");
				msg("index: $index");
			}

			// Now add the default network mapping
			$sql = "INSERT INTO network_mappings (loc_id, mount_point, clients, is_default) VALUES ($index, '$loc_url', '|Default|',1)";
			msg($sql);
			$db->query($sql);
			msg("Adding default mapping: $sql");
		}
		else{
			// Update location
			$db->query("UPDATE mp3location ".
			   "SET name= '$loc_name', ".
			   "description='$loc_comment', ".
			   "first_seen = NOW() ,last_seen=NOW(), last_update=NOW(), ".
			   "seconds_online=0, available = 1, ".
			   "basedir = '$loc_dir' ".
			   "WHERE id = $loc_change");
			
			// If this is the default mapping, we should update it with the new information.
			// If this is not the default mapping we should insert the new mount_point we
			// just configured.
			
			if ($loc_noDefault){
				// This is not the default mapping.  If $loc_accessPath is set then
				// this is an edit.  Otherwise this is a new path
				if ($loc_accessPath){
					$sql = "UPDATE network_mappings SET mount_point = '$loc_url', clients = '$loc_clients', is_default=0 WHERE loc_id = $loc_change AND mount_point = '$loc_accessPath'";
					$db->query($sql);
				}
				else{
					$sql = "INSERT INTO network_mappings (loc_id, mount_point, clients, is_default) VALUES ($loc_change, '$loc_url', '$loc_clients',0)";
					$db->query($sql);
				}
			}
			else{
				// Update default mapping
				$sql = "UPDATE network_mappings SET mount_point = '$loc_url', clients='|Default|' WHERE loc_id = $loc_change AND is_default=1";
				$db->query($sql);
			}
		
			rimps_msg("Location updated!");
			
		}
		echo "<a href='".$config['baseurl']."?action=location_admin'>Continue</a>";
	}

}
echo "</center>";

// Show all fields if there is a warning, but no errors
if ($warningMsg != '' && $errorMsg == ''){
	$showAll =1;
}
else{
	$showAll=0;
}

writeHiddenFields($showAll);
echo "</form>";
$GLOBALS['theme']->edge_title_end();

exit;
//**************************************************************************/
if (isset($index)){
	$db->query("SELECT * from mp3location WHERE id=$index");
	if ($db->next_record()){
		$loc_name = $db->f("name");
		$loc_type = $db->f("type");
		$loc_dir = $db->f("basedir");
		//$loc_baseurl = $db->f("baseurl");
		$loc_comment = $db->f("description");
		$loc_available = $db->f("available");
		$loc_first_seen = $db->f("first_seen");
		$loc_last_seen = $db->f("last_seen");
		$loc_seconds_online = $db->f("seconds_online");
		$loc_last_update = $db->f("last_update");
		$title="Edit Location";
	}
}
if (! isset($loc_name)){
	$loc_pri = 1;
	$loc_baseurl = "http://$SERVER_NAME";
	unset($index);
	$title = "New Location";
}
if (isset($new_cdrom)){
	$loc_type = "cdrom";
	$loc_baseurl = "/cdrom";
	$loc_dir = "/cdrom";
}

$GLOBALS["theme"]->edge_title($title,floor($GLOBALS["defwidth"]/2));
	?>

<form method="post" action="<?echo $config["index"] ?>">
<TABLE>
<TR>
<TD align="right"> Name: </TD>
<TD align="left"> <INPUT TYPE="text" NAME="loc_name" size="15" VALUE="<? echo $loc_name?>"> </TD>
<TD align="right"> Type: </TD>
<TD align="left"> <? selectbox ("loc_type",array("hd"=>"HD","cdrom"=>"CDROM"),$loc_type) ?>  </TD>
</TR>
<TR>
<TD align="right"> Directory: </TD>
<TD align="left" colspan="3">
<font size="-2">Directory on the server where the mp3s are located:</font><br>
<INPUT TYPE="text" NAME="loc_dir" VALUE="<? echo $loc_dir ?>" size="40"><br>
</TD>
</TR>
<?// Only show this if we are adding a NEW location
if ($index == ''){?>
<TR>
<TD align="right"> Default access path: </TD>
<TD align="left" colspan="3">
<font size="-2">URL to access these mp3s (http, or directoryname for local access only):</font><br>
<INPUT TYPE="text" NAME="loc_baseurl" size="40" value="<? echo $loc_baseurl ?>" >
</TD>
</TR>
<?}?>		
<TR>
<TD align="right"> Comment: </TD>
<TD align="left" colspan="3"> <INPUT TYPE="text" NAME="loc_comment" size="40" value="<? echo $loc_comment ?>"> </TD>
</TR>
<TR>
<TD align="center" colspan="4">
<INPUT TYPE="hidden" NAME="action" VALUE="location">
<?
if(isset($index)){
	echo "<INPUT TYPE=\"hidden\" NAME=\"index\" VALUE=\"$index\">\n";
	echo "<INPUT TYPE=\"submit\" VALUE=\"Change\" NAME=\"loc_change\">\n";
}else{
	echo "<input type=\"submit\" value=\"Add Location\" NAME=\"loc_add\">";
}

echo "</TD>\n</TR>\n</TABLE>";
//echo "</form>";

if ($index != ''){
	// Get network mappings
	$sql = "SELECT * FROM network_mappings where loc_id = $index";
	$db->query($sql);
	if ($db->num_rows()>0){
		echo "<center>";
		echo "<p><b>Summary of network mappings for clients</b>";
		echo "<table border=0>";
		//echo "<tr><td><b>Network path</b></td><td><b>Clients</b></td></tr>";
		while ($db->next_record()){
			$foundDefault += $db->f('is_default');
			echo "<tr><td>";
			echo implode(',', createClientArray($db->f('clients')));
			echo "</td><td><nobr> --&gt;</nobr></td><td>";
			echo $db->f('mount_point');
			echo "</td><td>";
			simpleLink($action, "Edit", "&index=$index&changeShare=".rawUrlEncode($db->f('mount_point')));
			echo ' ';
			simpleLink($action, "Del", "&index=$index&delShare=".rawUrlEncode($db->f('mount_point')));
			echo "</td></tr>";
		}
		echo "</table>";
		echo "</center>";
	}
	else{
		echo "<p><b>WARNING: You do not have any network mappings configured for ".
			"this location.  Until you add some mappings you will not be able ".
			"to access the mp3s in this location.";
	}
	if (!$foundDefault){
		echo "<p><b>WARNING: You do not have a default network mapping configured for ".
			"this location.  You will NOT be able to access mp3s found in this ".
			"share from clients you have not configured with Client Management";
	}
}
$GLOBALS["theme"]->edge_title_end();

if ($index != ''){

echo "<p>\n";
$GLOBALS["theme"]->edge_title("Add new point", $GLOBALS["defwidth"]/2);

// Controls to add new client mount points
?>
<b>Add new client mount point</b><br>
<font size=-2>Client mount points enable to you serve your MP3s over the local network
instead of streaming them over HTTP.  If a client or client group can access songs from the
RIMPS server directly instead of over HTTP, enter the path the client would use to access the 
files as "Network mount point" and choose the clients which can use this path.</font><p>
Network mount point: <input type=text size=40 name=mount_point value='<?echo $mount_point?>'><br>
<table border=0>
<tr><td valign=top>	
Clients:</td><td valign=top>
<?clientSelectBox('clients[]', $clients)?>
</td><td>
<font size=-1>
Choose the clients which have access to this location through the mount point described.
Hold down "ctrl" while clicking to select multiple clients.  To make this mapping a default
choose "Default".
</font>
</td></tr>
</table>
<input type=submit name=changeMountPoints value="Change mapping">
<?include('lib/hidden_fields.inc')?>
<input type='hidden' name='index' value='<?echo $index?>'>
</form>

<?php
$GLOBALS["theme"]->edge_title_end();
}
?>