<?
// Right now filter settings are stored in the session and are reset to defaults
// every time a user logs in.  This should be changed so that there is an whole
// user preference database that can store many preferences including active 
// filters.

// The $filter variable contains a list of active filters with the filter name as the key.  
// It would be nice to come up with a common data format so that the data in filter 
// would directly dictate changes to queries instead of having to write custom 
// code for each filter...

require 'lib/filter_functions.inc';

if (empty($db)){
	$db = new rimpsDB;
}

if ($changeFilter){
	// Set all filters to inactive
	$sql = "UPDATE filters SET active=0 WHERE aid = '".$GLOBALS['auth']->auth['uname']."'";
	$db->query($sql);
	
	reset($HTTP_POST_VARS);
	while (list($name, $val) = each($HTTP_POST_VARS)){
		if (ereg('filter_([[:alnum:]_]+)', $name, $matches)){
			msg ("Setting filter: ".$matches[1]);
			$sql = "UPDATE filters SET active =1 WHERE id = '".$matches[1].
			"' AND aid = '".$GLOBALS['auth']->auth['uname']."'";
			$db->query($sql);
		}
	}
	$filters = getActiveFilters();
}


$GLOBALS['theme']->edge_title("Filters", $GLOBALS['config']['site_width']/1.5);
// Show number filters
$sql = "SELECT count(*) FROM mp3data WHERE 1=1";
$withoutFilter = $db->simple_query($sql);
$sql .= processFilters($filters);
$withFilters = $db->simple_query($sql);
$totalFiltered = $withoutFilter - $withFilters;
echo "<center>$totalFiltered file(s) hidden due to ".sizeof($filters) ." active filter(s)</center><br>";

$sql = "SELECT * FROM filters WHERE aid = '".$auth->auth['uname']."'";
$db->query($sql);

?>
<form method=post action="<?echo $config['baseurl']?>">
<table border=0 cellspacing=3>
<?while($db->next_record()){?>
	<tr><td valign=top>
	<input type=checkbox name=filter_<?echo $db->f('id')?>
	<?if ($filters[$db->f('id')] || $filters[$db->f('sys_name')]){
		echo " CHECKED";
	}?> ></td><td>&nbsp;</td><td valign=top> <?echo $db->f('display'). '</td><td valign=top>';
	if ($db->f('sys_name')==''){
		createLink("delete_filter", "Del", '', '', '', '', '','', '', 'edit_filter='.$db->f('id'));
		echo " ";
		createLink("edit_filter", "Edit", '', '', '', '', '','', '', 'edit_filter='.$db->f('id'));
	}
	echo "</td></tr>";
}?>
</table>
<p>
<?createLink('edit_filter', "Create New Filter", $browse, $sort, $index)?>
<p>
<input type=submit name=changeFilter value=Change>
<?include('lib/hidden_fields.inc');?>
</form>
<?

$GLOBALS['theme']->edge_title_end();
	
?>
