<br>
<?php
require("engine/user_admin_functions.inc");

if(!is_object($auth))
	$auth = new rimpsAuth;
if(!is_object($perm))
	$perm = new rimpsPerm;

if (!is_object($sess)){
	$sess = new rimpsSess;
}

$class = $auth->database_class;
msg("Class: $class");
$db = new $class;

if($dbconfig["sqlserver"]=="mysql")
	$query="SHOW TABLES";
elseif($dbconfig["sqlserver"]=="pgsql")
	$query="SELECT tablename FROM pg_tables WHERE tablename NOT LIKE 'pg_%'";
else
	die("</td></tr></table><h2>Sorry unknown database type</h2>\n");

$db->query($query);

if($db->num_rows()>0)
	print "<h3>Your database already has ".$db->num_rows(). " tables</h3>\n";

//$dbconfig["sqlserver"]="pgsql";
if($db->num_rows()<5)
{
	$created=0;
	$fp=fopen("docs_info/table.".$dbconfig["sqlserver"],"r");
	while(!feof($fp))
		$create.=fread($fp,10240);
	fclose($fp);
	
	$db->Halt_On_Error="no";
	$queries=explode(";",$create);
	while(list($k,$d)=each($queries))
	{
		$d=trim($d);
		//mysql doesn't like to process comments through PHP so kill them.
		$d=ereg_replace("#[^\n]*\n","",$d);
		if(!empty($d))
			$db->query($d);
		
	}
	$db->Halt_On_Error="yes";
	
	echo "<h3>Created tables</h3><br>\n";
}


//------now add the initial admin account------
$query="SELECT count(*) FROM ".$auth->database_table;
$db->query($query);
$db->next_record();
if($db->Record[0]==0)
{
	if(empty($op)){
		echo "<b>Please create administrator account</b><p>\n";
		create_user_box("admin");
	}
	else{
		createuser($username,$password,$name,$email,$perms);
		echo "<p><a href = ".$config['baseurl'].">Start using RIMPS!</a>";
	}
}
else{
	echo "<p><a href = ".$config['baseurl'].">Start using RIMPS!</a>";
}
?>
