<br>
<br>

<?php
if (! $perm->check_nohalt("admin")){
    include("layout/end.inc");
    page_close();
    exit();
}

require 'lib/client_management_functions.inc';

if(empty($db))
	$db=new rimpsDB;

if ($delShare != ''){
	// Delete this share
	$sql = "DELETE FROM network_mappings WHERE loc_id = $index AND mount_point = '$delShare'";
	$db->query($sql);
	rimps_msg("Deleted mapping");
}


if ($mount_point!= ''){
	if (!is_array($clients)){
		rimps_error("You must select which clients have access to this mount point");
	}
	elseif(empty($index)){
		rimps_error("No file location is currently selected");
	}
	else{
		$clientString = createClientString($clients);
		if (strstr($clientString, '|Default|')){
			$is_default=1;
		}
		else{
			$is_default =0;
		}
		// Check to see if this mount_point and location already exist.  If the do
		// we will want to update instead of insert.
		$sql = "SELECT count(*) FROM network_mappings WHERE loc_id = $index AND ".
			"mount_point = '$mount_point'";
		$matches = $db->simple_query($sql);
		if ($matches > 0){
			// Already exists.  Update the row.
			$sql = "UPDATE network_mappings SET clients = '$clientString', ".
				"is_default = $is_default WHERE loc_id = $index AND ".
				"mount_point = '$mount_point'";
			$actionTaken = 'Updated';
		}
		else{
			// Row does not exist.  Insert
			$sql = "INSERT INTO network_mappings (mount_point, clients, loc_id, is_default)".
				" VALUES ('$mount_point', '$clientString', $index, $is_default)";
			$actionTaken = 'Added';
		}
		$success = $db->query($sql);
		if ($success){
			$mount_point='';
			$clients = '';
			rimps_msg("$actionTaken network access point");
		}
		else{
			rimps_error("Failed to add network access point");
		}
	}
}

if (isset($changeShare)){
	// Edit this share
	$sql = "SELECT clients FROM network_mappings WHERE loc_id = $index AND mount_point = '$changeShare'";
	$db->query($sql);
	if ($db->num_rows()<1){
		rimps_error("Share $changeShare does not exists for location $index");
	}
	else{
		$db->next_record();
		$mount_point = $changeShare;
		$clients = $db->f('clients');
	}
}

// Display add location wizard
include ('engine/add_location_wizard.inc');
?>
