<?
// Assumes there are global variables: 
//   $total = number of MB were selected
//   $matched = number of songs match selection
// Displays this information in a themed box
echo "<form action=".$GLOBALS['config']["index"]." method=post>";
echo "<input type=hidden name=action value='$action'>";
echo "<input type=hidden name=playlist_id value='$playlist_id'>";
echo "<input type=hidden name=browse value='$browse'>";
echo "<input type=hidden name=display value='$display'>";
echo "<input type=hidden name=page value='$page'>";
echo "<input type=hidden name=search value='$search'>";
echo "<input type=hidden name=sort value='$sort'>";
echo "<input type=hidden name=index value='$index'>";
$GLOBALS["theme"]->edge($GLOBALS["defwidth"]/2);
echo "<center>";
if ($playlist_id){
	showPlaylistName($playlist_id);
}
echo "<br>";
if($page>1)
	createLink ($action,"Prev ",$browse,$sort,$index,"","","","",
							"display=$display&search=$search&page=".($page-1));
if ($sort=='random'){
	// Don't display the pages.  It doesn't make any sense.
	createLink($action, "More Random",$browse,$sort,$index);
	echo "<br>";
}
elseif($matched>$config["num_per_page"]){
	echo " <font size=-1>[ ";
	$numPagerEntries = 8;
	$focusRange = 3;
	// $numPagerEntries helps limit how many entries show in the pager.  However, we want to 
	// have the pager show the entire range, so we will need to skip some
	// entries.  $focusRange defines how many pages to either side of the
	// selected page should be displayed WITHOUT skipping any pages
	
	//Lets calculate how many to skip.
	
	$totalPages = ceil($matched/$config['num_per_page']);
	if ($totalPages > $numPagerEntries){
		$focusLow = $page - $focusRange;
		$focusHigh = $page + $focusRange;
		$skips = ceil($totalPages/$numPagerEntries);
	}
	for($i=1; $i<=$totalPages; $i++)
	{
		if ($i%$skips ==0 || ($i >= $focusLow && $i<=$focusHigh) || $i==$totalPages || $i==1){	
			if ($i == $page)
				createLink ($action,"<b><font size=+0>" .$i."</font></b>",$browse,$sort,$index,"","","","",
										"page=$i&display=$display&search=$search");
			else
				createLink ($action,$i." ",$browse,$sort,$index,"","","","",
										"page=$i&display=$display&search=$search");
		}
	}
	echo " ]</font> ";
}
if($page<ceil($matched/$config["num_per_page"]) && $sort!='random'){
	createLink ($action,"Next ",$browse,$sort,$index,"","","","",
			"display=$display&search=$search&page=".($page+1));
	echo "<br>";
}

if ($matched>0 && $total >0){
	echo "$matched match";
	if ($matched > 1){
		echo "es";
	}
	echo " |\n";
	echo size_calc($total)." total |\n";
	echo time_calc($time). " time \n";
	echo "<br>";
}

echo "</center>\n";
$GLOBALS["theme"]->edge_end();
echo "</form>";
?>