<?
// This file is called once at session start up.  Use it to initialize any
// session variables, databases, etc.  Useful to register session variables
// or load frequently-used data into the session.
 
// NOTE: this file is included within a function, so access to global variables
// must be done explicitly.

msg("Executing auto_init.inc");

// Initalize session environment.  .
$GLOBALS['sess']->register("playlist_id");

// This variable is used to pass a query between pages which I don't feel comfortable
// passing through get or post.  I don't want it tampered with.
$sess->register("totalResultSetQuery");

// Tracks movement through the site
$GLOBALS['sess']->register("crumbs");
$GLOBALS['sess']->register('currentCrumb');

// An array of filter settings
// Set default filter
require('lib/filter_functions.inc');

//Make sure that all system filters have been loaded for this user.
initFilterDB();

// Load active filter set.
$GLOBALS['filters'] = getActiveFilters();
msg("filters var set up and set to $filters");
$GLOBALS['sess']->register('filters');

// Determine which client or client group a user belongs to
require('lib/client_management_functions.inc');
$GLOBALS['clientGroup'] = determineClient();
$GLOBALS['sess']->register('clientGroup');

// Set the listing template to standard
$GLOBALS['templatePreference'] = 'standard';
$GLOBALS['sess']->register('templatePreference');

?>