<?
if(!isset($FORM_FUNCS) and !isset($GLOBALS["FORM_FUNCS"]))://stop redefinition
$FORM_FUNCS=1;

function submit($name,$value="",$misc="")
{
	if(empty($value))
		$value=$name;
	if(!empty($misc) and substr($misc,0,1)!=" ")
		$misc=" ".$misc;
	echo "<input type=submit name=\"$name\" value=\"".stripslashes($value)."\"$misc>\n";
}

function resetbox($name,$value="",$misc="")
{
	if(empty($value))
		$value=$name;
	if(!empty($misc) and substr($misc,0,1)!=" ")
		$misc=" ".$misc;
	echo "<input type=reset name=$name value=\"".stripslashes($value)."\"$misc>\n";
}

function selectbox($name,$array,$misc="",$default="~~~",$index_mode="key")
{
	if(!is_array($array))
	{
		echo "Error reading array for $name<br>\n";
		return(-1);
	}
	if($default=="~~~")
	{
		if(isset($GLOBALS[$name]))
			$default=$GLOBALS[$name];
		else
			$default="";
	}
	elseif(is_array($default))
	{
		unset($tmp);
		while(list($key,$data)=each($default))
		{
			if(ereg("^[0-9]+$",$key))
				$tmp[$data]=$data;
			else
				$tmp[$key]=$data;
		}
		if(isset($tmp))
			$default=$tmp;
	}
	
	echo "<select name=\"$name\"";
	if($misc!="")
		echo " $misc";
	echo ">\n";
	if(is_array($array) and count($array)>0)
	{
		reset($array);
		while(list($key,$data)=each($array))
		{
			if(ereg("null \\[.*\\]",$key))
				$key="";
			if(ereg("key",$index_mode))
				echo "		<option value=\"".stripslashes($key)."\"";
			else
				echo "		<option";
			if((ereg("case",$index_mode) AND strtolower($default)==strtolower($key) and ereg("key",$index_mode)) or
				 (ereg("case",$index_mode) AND strtolower($default)==strtolower($data) and !ereg("key",$index_mode)) or
				 ($default==$key and ereg("key",$index_mode)) or
				 ($default==$data and !ereg("key",$index_mode)) or
				 (is_array($default) and (($default[$key] and ereg("key",$index_mode)) or
																	($default[$data] and !ereg("key",$index_mode)))))
			{
				echo " SELECTED";
			}
			echo ">".$data."\n";
		}
		echo "</select>";
	}
}

function radiobox($name,$value,$checked=0,$misc="")
{
	if($checked=="")
		$checked=FALSE;
	echo "<input type=radio name=\"$name\" value=\"$value\"";
	if($checked==TRUE or (isset($GLOBALS[$name]) && $GLOBALS[$name]==$value))
		echo " CHECKED";
	if($misc!="")
		echo " $misc";
	echo ">\n";
}

function checkbox($name,$value="",$checked=0,$misc="")
{
	if(empty($value))
		$value=$name;
	
	echo "<input type=checkbox name=\"$name\" value=\"$value\"";
	if($checked==true or isset($GLOBALS[$name]))
	{
		echo " CHECKED";
	}
	if($misc!="")
		echo " $misc";
	echo ">\n";
}

function textbox($name,$size=0,$maxlength=0,$value="",$misc="")
{
	if($value=="" and isset($GLOBALS[$name]))
		$value=$GLOBALS[$name];
	if(empty($value))
		$value="";
	echo "<input name=\"$name\" type=text";
	if($size>0)
		echo " size=$size";
	if($maxlength>0)
		echo " maxlength=$maxlength";
	$val=$value;
	echo " value=\"".stripslashes($value)."\"";
	if($misc!="")
		echo " $misc";
	echo ">\n";
}

function filebox($name,$size=0,$maxlength=0,$value="",$misc="")
{
	if($value=="" and isset($GLOBALS[$name]))
		$value=$GLOBALS[$name];
	if(empty($value))
		$value="";
	echo "<input name=\"$name\" type=file";
	if($size>0)
		echo " size=$size";
	if($maxlength>0)
		echo " maxlength=$maxlength";
	echo " value=\"".stripslashes($value)."\"";
	if($misc!="")
		echo " $misc";
	echo ">\n";
}

function passwordbox($name,$size=0,$maxlength=0,$value="",$misc="")
{
	if($value=="" and isset($GLOBALS[$name]))
		$value=$GLOBALS[$name];
	if(empty($value))
		$value="";
	echo "<input name=\"$name\" type=password";
	if($size>0)
		echo " size=$size";
	if($maxlength>0)
		echo " maxlength=$maxlength";
	echo " value=\"".stripslashes($value)."\"";
	if($misc!="")
		echo " $misc";
	echo ">\n";
}

function hiddenfield($name,$value="",$misc="")
{
	if($value=="" and isset($GLOBALS[$name]))
		$value=$GLOBALS[$name];
	if(empty($value))
		$value="";
	echo "<input type=hidden name=\"$name\" value=\"".stripslashes($value)."\"";
	if($misc!="")
		echo " $misc";
	echo ">\n";
}

function textarea($name,$cols=0,$rows=0,$value="",$misc="")
{
	if($value=="" and isset($GLOBALS[$name]))
		$value=$GLOBALS[$name];
	if(empty($value))
		$value="";
	echo "<textarea name=\"$name\"";
	if($cols>0)
		echo "cols=$cols";
	if($rows>0)
		echo " rows=$rows";
	if($misc!="")
		echo " $misc";
	echo ">".stripslashes($value)."</textarea>\n";
}


// Constants for the following function.	These are used in the function and as
// constants when calling the function so they must be declared outside the 
// function to be global as this is the closest thing that PHP3 has to a
// #define directive
$ERROR_SCREEN=1;
$ERROR_MAIL=2;
$ERROR_BACK=4;
$ERROR_CENTER=8;
$ERROR_EXIT=16;

define("ERROR_SCREEN",1);
define("ERROR_MAIL",2);
define("ERROR_BACK",4);
define("ERROR_CENTER",8);
define("ERROR_EXIT",16);

function error_out($err,$level=19)
{
	// level is a bit field to determine action
	//	1	output to the screen
	//	2	send out mail
	//	4	offer a go back link
	//	8	center output
	// 16	exit upon completion
	// 
	global $PHP_SELF,$debug;
	
	if(!isset($level) || $level==0)
		$level=ERROR_SCREEN|ERROR_MAIL;
	
	if($level & ERROR_SCREEN)
	{
		echo "<br>\n";
		echo "<center><img src=\"/images/failed.gif\" alt=\"Query Failed\"></center>\n";
		echo "<hr>\n";
		if($level & ERROR_CENTER)
			echo "<center>\n";
		else
			echo "</center>\n";
	}
	
	if(is_array($err))
	{
		$cnt=count($err);
		$x=0;
		while($x<$cnt)
		{
			$out.=$err[$x]."<br>\n";
			$x++;
		}
	}
	elseif(is_string($err))
	{
		if(eregi("<br>",$err))
			$out=$err;
		else
			$out=eregi_replace(10,"<br>\n",$err);
	}
	
	if($level & ERROR_MAIL || isset($debug))
	{
		mail($GLOBALS["SERVER_ADMIN"],"Error on page $PHP_SELF",
				 "Error on page $PHP_SELF\n".
				 "Level: $level	Debug=$debug\n",
				 ereg_replace("<br>\n","\n",$out));
	}
	if($level & ERROR_SCREEN or $level & ERROR_BACK)
	{
		echo $out."<br>\n";
		
		if($level & ERROR_BACK)
		{
			if(eregi("(ozilla.[234]|MSIE.3)",$GLOBALS["HTTP_USER_AGENT"]))
				echo("Press <a href=\"javascript:history.go(-1)\">Here</a> to go back and correct these errors<br>\n");
			else
				echo("Press your 'BACK' button and correct these errors then submit again<br>\n");
		}
		if($level & ERROR_EXIT)
		{
			echo("</table>\n");
			include($GLOBALS["DOCUMENT_ROOT"]."/footer.inc");
		}
		@mysql_close();
	}
	else
	{
		echo "<h2>Unable to process query at this time<br>\n";
		echo "Try again later</h2>\n";
	}
	if($level & ERROR_EXIT)
		exit;
	if($level & ERROR_CENTER)
		echo "</center>\n";
}


function mysql_send_query($db,$query,$host="saturn",$user="WWW",$password="")
{
	global $PHP_SELF;
	global $mysql_link;
	global $mysql_link_id;
	global $debug;
	
	if(empty($query))
		return(FALSE);
	//echo "mysql_link=$mysql_link<br>\n";	
	//echo "mysql_link_id[mysql_link]=$mysql_link_id[$mysql_link]<br>\n";	
	//if(!isset($mysql_link) or $mysql_link_id[$mysql_link]!="$host-$user-$password")
	//{
	$retrys=0;
	while(($mysql_link=mysql_pconnect($host,$user,$password))==FALSE and $retrys<10)
	{
		$retrys++;
		if($retrys==9 and empty($restart))
		{
			system("/usr/local/bin/mysqladmin reload");
			$retrys=0;
			$restart=1;
		}
		elseif($retrys==9 and $restart==1)
		{
			mysqlkill();
			$retrys=0;
			$restart=100;
		}
		//}
		if($mysql_link==FALSE)
			die("Unable to Connect to database ($host)<br>\n[$query]");
		//$mysql_link_id[$mysql_link]="$host-$user-$password";
	}
	
	
	$retrys=0;
	while(mysql_select_db($db,$mysql_link)==FALSE and $retrys<10)
		$retrys++;
	if($retrys>=10)
		die("Unable select database ($db) on link $mysql_link<br>\n[$query]");
	
	if(!empty($debug))
	{
		echo "[$query]\n";
		ereg("(\.[0-9]+) ([0-9]+)",microtime(),$time);
		$starttime=doubleval($time[1])+doubleval($time[2]);
	}
	$result=mysql_query($query,$mysql_link);
	if(!isset($result) or $result<=0)
	{
		error_out("Query='$query'<br>\n".
							"Query Error : ".mysql_error()."<br>\n",ERROR_SCREEN | ERROR_MAIL | ERROR_EXIT);
		exit;
	}
	if(!empty($debug))
	{
		ereg("(\.[0-9]*) ([0-9]*)",microtime(),$time);
		$endtime=doubleval($time[1])+doubleval($time[2]);
		echo "(".number_format($endtime-$starttime,4)."	Seconds)<br>\n";
	}
	return($result);
}

function array_append($array1,$array2)
{
	for($x=0; $x<count($array2); $x++)
		$array1[count($array1)]=$array2[$x];
	return($array1);
}

function array_to_str($array)
{
	for($x=0; $x<count($array); $x++)
		$str.=$array[$x].", ";
	return(substr($str,0,strlen($str)-2));
}


function mysqlkill()
{
	system("/etc/rc.d/init.d/mysql stop &>/dev/null");
	system("/usr/local/bin/mysqladmin shutdown &>/dev/null");
	sleep(1);
	exec("ps axw",$lines);
	print "lines=".count($lines)."<br>\n";
	for($x=0; $x<count($lines); $x++)
	{
		if(ereg("mysqld",$lines[$x]))
		{
			$pid=ereg_replace("^ *([0-9]*) .*","\\1",$lines[$x]);
			exec("kill $pid &>/dev/null");
			//print "pid=$pid\n";
		}
	}
}

$GLOBALS["STATE_ARRAY"]=array("AL"=>"Alabama","AK"=>"Alaska","AZ"=>"Arizona",
															"AR"=>"Arkansas","CA"=>"California","CO"=>"Colorado",
															"CT"=>"Connecticut","DE"=>"Delaware","DC"=>"Dist of Columbia",
															"FL"=>"Florida","GA"=>"Georgia","HI"=>"Hawaii","ID"=>"Idaho",
															"IL"=>"Illinois","IN"=>"Indiana","IA"=>"Iowa","KS"=>"Kansas",
															"KY"=>"Kentucky","LA"=>"Louisiana","ME"=>"Maine",
															"MD"=>"Maryland","MA"=>"Massachusetts","MI"=>"Michigan",
															"MN"=>"Minnesota","MS"=>"Mississippi","MO"=>"Missouri",
															"MT"=>"Montana","NE"=>"Nebraska","NV"=>"Nevada",
															"NH"=>"New Hampshire","NJ"=>"New Jersey","NM"=>"New Mexico",
															"NY"=>"New York","NC"=>"North Carolina","ND"=>"North Dakota",
															"OH"=>"Ohio","OK"=>"Oklahoma","OR"=>"Oregon",
															"PA"=>"Pennsylvania","RI"=>"Rhode Island",
															"SC"=>"South Carolina","SD"=>"South Dakota","TN"=>"Tennessee",
															"TX"=>"Texas","UT"=>"Utah","VT"=>"Vermont","VA"=>"Virginia",
															"WA"=>"Washington","WV"=>"West Virginia","WI"=>"Wisconsin",
															"WY"=>"Wyoming","PR"=>"Puerto Rico");


function ucfirstword($str)
{
	$arr=explode(" ",$str);
	$count=count($arr);
	$x=0;
	while($x<$count)
	{
		$arr[$x]=ucfirst($arr[$x]);
		$x++;
	}
	$str=implode($arr," ");
	return($str);
}

endif;
?>
