<?
//Set up an array to store tags in

//require 'lib/id3_class.inc';
require 'lib/mp3info.inc';

function getID3GenreList(){
	return array(
				"Blues", "Classic Rock", "Country", "Dance", "Disco", "Funk",
				"Grunge", "Hip-Hop", "Jazz", "Metal", "New Age", "Oldies", "Other",
				"Pop", "R&B", "Rap", "Reggae", "Rock", "Techno",
				"Industrial", "Alternative", "Ska", "Death Metal", "Pranks",
				"Soundtrack", "Euro-Techno", "Ambient", "Trip-Hop", "Vocal",
				"Jazz+Funk", "Fusion", "Trance", "Classical", "Instrumental",
				"Acid", "House", "Game", "Sound Clip", "Gospel", "Noise",
				"AlternRock", "Bass", "Soul", "Punk", "Space", "Meditative",
				"Instrumental Pop", "Instrumental Rock", "Ethnic", "Gothic",
				"Darkwave", "Techno-Industrial", "Electronic", "Pop-Folk",
				"Eurodance", "Dream", "Southern Rock", "Comedy", "Cult", "Gangsta",
				"Top 40", "Christian Rap", "Pop/Funk", "Jungle", "Native American",
				"Cabaret", "New Wave", "Psychedelic", "Rave", "Showtunes", "Trailer",
				"Lo-Fi", "Tribal", "Acid Punk", "Acid Jazz", "Polka", "Retro",
				"Musical", "Rock & Roll", "Hard Rock", "Folk", "Folk/Rock",
				"National Folk", "Swing", "Fast-Fusion", "Bebob", "Latin", 
				"Revival", "Celtic", "Bluegrass", "Avantgarde", "Gothic Rock", 
				"Progressive Rock", "Psychedelic Rock", "Symphonic Rock", 
				"Slow Rock", "Big Band", "Chorus", "Easy Listening", 
				"Acoustic", "Humour", "Speech", "Chanson", "Opera", 
				"Chamber Music", "Sonata", "Symphony", "Booty Bass",
				"Primus", "Porn Groove", "Satire", "Slow Jam", "Club", "Tango",
				"Samba", "Folklore", "Ballad", "Power Ballad", "Rhythmic Soul",
				"Freestyle", "Duet", "Punk Rock", "Drum Solo", "A capella",
				"Euro-House", "Dance Hall", "Goa", "Drum & Bass", "Club-House",
				"Hardcore", "Terror", "Indie", "BritPop", "Negerpunk", "Polsk Punk",
				"Beat", "Christian Gangsta Rap", "Heavy Metal", "Black Metal", "Crossover",
				"Contemporary Christian", "Christian Rock", "Merengue", "Salsa", 
				"Trash Metal", "Anime", "Jpop", "Synthpop"
				);
}

// adapter to the MP3Info object
function readID3($filename){
	// uses mp3info object
	$mi = new MP3Info;
	if (!$mi->read($filename)){
		echo "ERROR: failed to read $filename";
	}
	else{
		$mp3data['artist'] = $mi->artist;
		$mp3data['title'] = $mi->title;
		$mp3data['genre']= $mi->genre;
		$mp3data['album']= $mi->album;
		$mp3data['comment']= $mi->comment;
		$mp3data['year']= $mi->year;
		$mp3data['sec']= $mi->sec;
		$mp3data['layer']= $mi->layer;
		$mp3data['samplerate']= $mi->samplerate;
		$mp3data['channel']= $mi->channel;
		$mp3data['bitrate'] = $mi->bitrate;
		$mp3data['track'] = $mi->track;
		$mp3data['mpeg'] = $mi->mpeg;
		$mp3data['size'] = $mi->filesize;
		
	}
	//echoArray($mp3data);
	return $mp3data;
}


function echoArray($array){
	reset ($array);
	while(list($key, $val) = each($array)){
		echo "$key = $val<br>\n";
	}
	echo "<p>";
}

/*
// Comparative adapter
function readID3($filename){
	// first id3info
	$layer['1'] = 'Layer I';
	$layer['2'] = 'Layer II';
	$layer['3'] = 'Layer III';
	$mi = new id3($filename);
	$obj = 'id3';
	//$mp3data[$obj]['obj'] = $obj;
	$mp3data[$obj]['filename'] = $filename;
	$mp3data[$obj]['artist'] = $mi->artists;
	$mp3data[$obj]['title'] = $mi->name;
	$mp3data[$obj]['genre']= $mi->genre;
	$mp3data[$obj]['album']= $mi->album;
	$mp3data[$obj]['comment']= $mi->comment;
	$mp3data[$obj]['year']= $mi->year;
	$mp3data[$obj]['sec']= $mi->lengths;
	$mp3data[$obj]['layer']= $layer[$mi->layer];
	$mp3data[$obj]['bitrate'] = $mi->bitrate;
	
	$mi = new MP3Info;
	$obj = 'mp3';
	$mi->read($filename);
	//$mp3data[$obj]['obj'] = 'mp3info';
	//$mp3data[$obj]['filename'] = $filename;
	//$mp3data[$obj]['artist'] = $mi->artist;
	//$mp3data[$obj]['title'] = $mi->title;
	//$mp3data[$obj]['genre']= $mi->genre;
	//$mp3data[$obj]['album']= $mi->album;
	//$mp3data[$obj]['comment']= $mi->comment;
	//$mp3data[$obj]['year']= $mi->year;
	//$mp3data[$obj]['sec']= $mi->sec;
	//$mp3data[$obj]['layer']= $mi->layer;
	$mp3data[$obj]['bitrate'] = $mi->bitrate;
	
	$mp3 = $mp3data['mp3'];
	$id3 = $mp3data['id3'];
	reset($mp3);
	reset($id3);
	$fn = 1;
	while(list($key, $val) = each($mp3)){
		if (trim($val) != trim($id3[$key])){
			if ($fn){
				echo "$filename<br>\n";
				$fn=0;
			}
			echo "$key --> $val | ".$id3[$key]."<br>\n";
		}
	}
	echo "<p>";
}
*/


/*
// adapter to the id3 object
function readID3($filename){
	// uses mp3info object
	$mi = new id3($filename);

		$mp3data['obj'] = 'id3';
		$mp3data['filename'] = $filename;
		$mp3data['artist'] = $mi->artists;
		$mp3data['title'] = $mi->name;
		$mp3data['genre']= $mi->genre;
		$mp3data['album']= $mi->album;
		$mp3data['comment']= $mi->comment;
		$mp3data['year']= $mi->year;
		$mp3data['sec']= $mi->lengths;
		$mp3data['layer']= $mi->layer;
		//$mp3data['samplerate']= $mi->samplerate;
		//$mp3data['channel']= $mi->channel;
		$mp3data['bitrate'] = $mi->bitrate;

	//echoArray($mp3data);
	return $mp3data;
	
	
}
*/

/*


$mi = new MP3Info;
	if (! $mi->read($filename)){
		echo $mi->errormsg."<br> -> not Added!<br>\n";
		return;
	}
	$filename = addslashes(str_replace("$basedir/","",$filename));

	if ($old_size_title[$mp3data["size"].$mp3data["title"]]){
		$id=$old_size_title[$mp3data["size"].$mp3data["title"]];
	}
	if ($old_filename[$filename]){
		$id=$old_filename[$filename];
	}
	
	$artist = addslashes(stripslashes($mi->artist));
	$title = addslashes(stripslashes($mi->title));
	$genre = addslashes(stripslashes($mi->genre));
	$album = addslashes(stripslashes($mi->album));
	$comment = addslashes(stripslashes($mi->comment));
	$year = addslashes(stripslashes($mi->year));
	$filename = addslashes(stripslashes($filename));
	$track = addslashes(stripslashes($mi->track));
	$sec = addslashes(stripslashes($mi->sec));

	$mpeg= addslashes(stripslashes($mi->mpeg));
	$layer= addslashes(stripslashes($mi->layer));
	$bitrate= addslashes(stripslashes($mi->bitrate));
	$samplerate= addslashes(stripslashes($mi->samplerate));
	$channel= addslashes(stripslashes($mi->channel));



function readID3($filename){
	
	if (file_exists($filename)){
		$filehandle = fopen($filename, 'rb');
	}
	else{
		//echo "$filename does not exist<br>";
		msg("File does not exist: $filename");
		return false;
	}
	

	// Set up an array of genre names
	$genrename = getID3GenreList();
	
	//Put the size in the array
	$mp3data["size"] = filesize($filename);
	$size = $mp3data['size'];
	//echo "size of $file ". $mp3data['size'];

	// Get the last 128 bytes and see if there's a TAG there
	$seek = fseek($filehandle, $size-128);
	$tag = fread($filehandle,128);
	// Grab last char for the Genre
	// This can get confused for EOF with fgets
	
	// This won't happen if you open file binary safe...
	
	//$seek = fseek($filehandle, $size-1);
	//$gen = fgetc($filehandle);

	if (stristr($tag, "TAG")){
		// Strip padded 0s from Grip-made tags
		$pad = pack("c", 0x00);

		// Extract the tag data and close the file
		// This is the correct order... 

		$mp3data["title"] = trim(str_replace($pad,"",substr($tag,3, 30)));
		$mp3data["artist"] = trim(str_replace($pad,"",substr($tag,33, 30)));
		$mp3data["album"] = trim(str_replace($pad,"",substr($tag,63, 30)));
		$tmp = trim(str_replace($pad,"",str_replace("_","",substr($tag,93, 4))));
		if ($tmp != ''){
			$mp3data['year'] = $tmp;
		}
		$mp3data["comment"] = trim(str_replace($pad,"",substr($tag,97,28)));
		
		// Support for ID3v1.1:
		$switch = substr($tag, 125, 1);
		$track = substr($tag, 126,1);
		if (ord($switch) == 0){
			// This is an ID3v1.1 tag
			$mp3data['track'] = ord($track);
		}
		else{
			// Not ID3
			$mp3data['comment'] .= $switch . $track;
			$mp3data['track'] = '';
		}
		
		$mp3data["genre"] = $genrename[ord(substr($tag, 127, 2))];
		fclose($filehandle);
	}
	else
	{
		//just use the filename for title if no tags
		$mp3data["title"] = str_replace("'","\\'",$filelist[$iz]);
		//echo "id3 tag ($tag) not found<br>";
		fclose($filehandle);
	}
	
	return $mp3data;
}
*/
?>