<?php
// MySQL routines... comments or suggestions: dszego@mindslip.com (David Szego)
// 
function SQLString ($string) 
{
  $string = addslashes($string);
  return $string;
}

function sqlsearchstring () 
{ 
  return "^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2})";
}

function createSqlDate($year, $month, $day) 
{
  return sprintf( "%04d-%02d-%02d", $year, $month, $day);
}

function createSqlDateTime($year, $month, $day, $hour, $min, $sec) 
{
  return sprintf( "%04d-%02d-%02d %02d:%02d:%02d", $year, $month, $day, $hour, $min, $sec);
}

function sqlDuringDay($datestr) 
{
  return "start > '$datestr 00:00' AND start < '$datestr 23:59'";
}

function convertSQLTimetoUTime( $sqldate ) 
{
  return( mktime( substr( $sqldate, 11, 2 ), substr( $sqldate, 13, 2 ), substr( $sqldate, 15, 2 ), substr( $sqldate, 5, 2 ), substr( $sqldate, 8, 2 ), substr( $sqldate, 0, 4 ) ) );
}

function MakeInsertString ($data) 
{
  while ( list( $key, $val ) = each( $data ) ) 
  {
    if( $val != "--remove" ) 
    {
      $string["fields"] .= "$key, ";
      $string["values"] .= "'" . SQLString($val) . "', ";
    }
  }
  $string["fields"]=ereg_replace(", $","",$string["fields"]);
  $string["values"]=ereg_replace(", $","",$string["values"]);
  
  return $string;
}

function MakeUpdateString ($data) 
{
  while ( list( $key, $val ) = each( $data ) ) 
  {
    if ($data[$key]) 
      $strings .= $key . " = '" . SQLString($val) . "', ";
  }
  $strings=ereg_replace(", $", " ", $strings);
  return $strings;
}

function dbQuery ($statement) 
{
  global $dbconfig;
  
  //Connect to the database
  
  $connhost = "$dbconfig[sqlhost]";
  if ($dbconfig[sqlport] != "") 
    $connhost = $connhost . ":$dbconfig[sqlport]";   
  if ($dbconfig[sqlusername] != "") 
    $connuser = "$dbconfig[sqlusername]"; 
  if ($dbconfig[sqlpassword] != "") 
    $connpass = "$dbconfig[sqlpassword]"; 
  
  $db=mysql_connect($connhost,$connuser,$connpass);
  
  if ($db < 1) 
  {
    echo "<br>dbConnect error: " . mysql_errno() . ": " . mysql_error() . "<BR>";
    return 0;
  }
  
  //Select the database
  if ($dbconfig[sqldb] != "") 
    $dbname=$dbconfig[sqldb];  
  $dbSelect = mysql_select_db("$dbname",$db);
  
  if (!$dbSelect) 
  { 
    echo "<Br>dbSelect error: " . mysql_errno() . ": " . mysql_error() . "<BR>";
    return 0; 
  }
  
  //Execute the query
  $result=mysql_db_query("$dbname","$statement");
  if($result < 1) 
  {
    echo "<br>dbQuery error: " . mysql_errno() . ": " . mysql_error() . " doing: $statement<br>";
  }
  mysql_close($db);
  return $result;
}


function dbResult ($result,$i,$field) 
{
  return mysql_Result($result,$i,$field);
}


function dbNumRows ($result) 
{
  if ($result < 0) 
    return "";
  
  return mysql_num_rows($result);
}


function dbResultArray ($result,$i) 
{
  if (!$result)
    return "";
  return mysql_fetch_array($result,$i);
}

function dbFetchRow ($result,$i) 
{
  if (!$result)
    return "";
  return mysql_fetch_row($result);
}
?>
